/*Biblioteca de Diides - Eduard Montgomery Meira Costa, DSc - 2002*/

/* ---------------------------------------------------------------------
Operaes:
oplus_rminmax gera a operao de soma para Rmax (m = FALSE) e para Rmin (m = TRUE)
otimes_rminmax gera a operao de multiplicao para Rmax e para Rmin
oplus_l gera a operao de soma para linguagens temporizadas ou no
otimes_l gera a operao de multiplizao para linguagens temporizadas ou no

As entradas so dadas como strings para todas as operaes, sendo as respectivas sadas
strings tambm.

Os elementos nulo e identidade so dados por '' e 'i', respectivamente.

A palavra vazia, para o caso de linguagens,  representada por 'e'
  --------------------------------------------------------------------- */

char *oplus_rminmax(char*, char*, BOOL);
char *otimes_rminmax(char*, char*);
char *oplus_l(char*, char*);
char *otimes_l(char*, char*);
char *limpa(char*);

char *oplus_rminmax (char *a, char *b, BOOL m){
int at, bt, result;
char atemp[10];

if (!m){
	if (!strcmp(a, "i")) at = 0;
	else if (!strcmp(a, "")) at = -30000;
		  else at = atoi(a);
	if (!strcmp(b, "i")) bt = 0;
	else if (!strcmp(b, "")) bt = -30000;
		  else bt = atoi(b);
   result = max(at, bt);
   if (result == -30000) strcpy(atemp, "");
   else if(result == 0) strcpy(atemp, "i");
   	  else itoa (result, atemp, 10);
   return &atemp[0];
   }
else{
	if (!strcmp(a, "i")) at = 0;
	else if (!strcmp(a, "")) at = 30000;
		  else at = atoi(a);
   if (!strcmp(b, "i")) bt = 0;
	else if (!strcmp(b, "")) bt = 30000;
		  else bt = atoi(b);
   result = min(at, bt);
   if (result == 30000) strcpy(atemp, "");
   else if(result == 0) strcpy(atemp, "i");
   	  else itoa (result, atemp, 10);
   return &atemp[0];
   }
}

char *otimes_rminmax (char *a, char *b){
int at, bt, result;
char atemp[10];

if (!strcmp(a, "i")) return b;
else if (!strcmp(a, "")) return a;
	  else if (!strcmp(b, "i")) return a;
     		 else if (!strcmp(b, "")) return b;
          		else {
						at = atoi(a);
						bt = atoi(b);
						result = at + bt;
						itoa (result, atemp, 10);
						return &atemp[0];
                  }

}

char *otimes_l (char *a, char *b){
int k, l, i, i1;
char temp[500], *temp1, atemp[50], btemp[50], bttemp[10], attemp[10], *rest, *att, *btt;
strcpy (temp, "");
k = 0;
l = 0;
do {
	i = 0;
   i1 = 0;
   while ((a[k] != '+') && (a[k] != '\0')){
   	if ((a[k] == 'i') || (a[k] == '')) {
      	attemp[i1] = a[k];
         attemp[i1+1] = '\0';
         }
      else if (isdigit (a[k])){
      		attemp[i1]=a[k];
            attemp[i1+1] = '\0';
            i1++;
            }
           else {
		   	atemp[i] = a[k];
      		atemp[i+1] = '\0';
		      i++;
            }
      k++;
      }
   att = &attemp[0];
   do{
   	i = 0;
      i1 = 0;
      while ((b[l] != '+') && (b[l] != '\0')){
   	if ((b[l] == 'i') || (b[l] == '')) {
      	bttemp[i1] = b[l];
         bttemp[i1+1] = '\0';
         }
      else if (isdigit (b[l])){
      		bttemp[i1]=b[l];
            bttemp[i1+1] = '\0';
            i1++;
            }
           else {
      			btemp[i] = b[l];
         		btemp[i+1] = '\0';
         		i++;
               }
         l++;
         }
      btt = &bttemp[0];
      rest = otimes_rminmax(att, btt);
      if(strcmp(rest, "")){
      	if (strcmp(rest, "0")) strcat(temp, rest);
         if (strcmp(atemp, "e"))
		      strcat(temp, atemp);
         if (strcmp(btemp, "e"))
	   	   strcat(temp, btemp); 
         if (!strcmp(atemp, "e") && !strcmp(btemp, "e"))
         	strcat(temp, "e"); 
         }
      if (l < strlen(b)){
      	if (strcmp(temp, ""))
	      	strcat (temp, "+");
         l++;
         }
      }while (l < strlen (b));
   strcpy (atemp, "");
   if (k < strlen (a)){ 
   	if (strcmp(temp, ""))
   		strcat (temp, "+");
      k++;
      l = 0;
      }
   }while ((k < strlen (a)) && (l < strlen (b)));
temp1 = limpa (temp);
return &temp1[0];
}

char *oplus_l(char *a, char *b){
char temp[500], *temp1;
strcpy (temp, "");
strcpy (temp, a);
if (b != "")
	strcat (temp, "+");
strcat (temp, b);
temp1 = limpa (temp);
return &temp1[0];
}

char *limpa(char *tempm){
char btempm[5000][50], atempm[5000], attemp[50], bttemp[5000][50], *rest;
int i, j, k, l, i1;
strcpy(atempm, "");
strcpy(attemp, "");
for (i = 0; i < 500; i ++){
	strcpy(btempm[i], "");
   strcpy(bttemp[i], "");
   }
j = 0;
k = 0;
do{
	i = 0;
	i1 = 0;
   while ((tempm[k] != '+') && (tempm[k] != '\0')){
   	if ((tempm[k] == 'i') || (tempm[k] == '')) {
      	attemp[i1] = tempm[k];
         attemp[i1+1] = '\0';
         i1++;
         }
      else if (isdigit (tempm[k])){
      		attemp[i1]=tempm[k];
            attemp[i1+1] = '\0';
            i1++;
            }
           else {
		   	atempm[i] = tempm[k];
      		atempm[i+1] = '\0';
		      i++;
            }
      k++;
      }
   strcpy (btempm[j], atempm);
   strcpy (bttemp[j], attemp); 
	strcpy(atempm, ""); 
	strcpy(attemp, "");
   k++;
   j++;
   }while (k < strlen (tempm));
for (k = 0; k < j; k++)
	for (l = k+1; l < j; l++){
   	if((!strcmp(btempm[k], btempm[l])) && (strcmp(btempm[k], ""))){
	   	rest = oplus_rminmax(bttemp[k], bttemp[l], FALSE);
         if (strcmp(rest, "") && strcmp(rest, "0")) strcpy(bttemp[k], rest);
         else if (!strcmp(rest, "0")) strcpy(bttemp[k], "i");
      	strcpy(btempm[l], "");
         strcpy(bttemp[l], "");
         }
      }
strcpy(atempm, "");
for (k = 0; k < j; k++)
	if (strcmp(btempm[k], "") && strcmp(bttemp[k], "")){
   	strcat(atempm, bttemp[k]);
   	strcat(atempm, btempm[k]);
      strcat(atempm, "+");
      }
if(atempm[strlen(atempm) - 1] == '+')
	atempm[strlen(atempm) - 1] = '\0';

tempm = &atempm[0];
return &tempm[0];
}
